function [reg,grad] = block_reg(y)

m = length(y);
d = sqrt(m);

if nargout == 1
    reg = sum(sqrt(sum(reshape(y,d,d).^2,1)));    
    reg = reg + sum(sqrt(sum(reshape(y,d,d).^2,2)));
else
    vec = sqrt(sum(reshape(y,d,d).^2,1));
    reg = sum(vec);    
    grad = reshape(y,d,d)./(ones(d,1)*vec);
    grad(:,vec==0) = 0;
    vec = sqrt(sum(reshape(y,d,d).^2,2));
    reg = reg + sum(vec);
    grad = grad+reshape(y,d,d)./(vec*ones(1,d));
    grad(vec==0,:) = 0;
    grad = reshape(grad,size(y));
end;